static DH *get_dh512(void)
{
    static unsigned char dhp_512[] = {
        0xF4, 0x8D, 0x50, 0xF1, 0x77, 0xBC, 0x42, 0x0F, 0xC6, 0xF9,
        0x07, 0x76, 0xF2, 0x08, 0xC3, 0x55, 0x35, 0x34, 0xF9, 0xF6,
        0xEE, 0x3A, 0x15, 0x1A, 0x0E, 0x5F, 0xBC, 0xD8, 0xFB, 0xA0,
        0x12, 0x74, 0x24, 0xD1, 0x5A, 0x22, 0x16, 0x6B, 0xC5, 0xC2,
        0xB0, 0x25, 0x3B, 0x42, 0x55, 0xB6, 0xC4, 0xDF, 0x5F, 0x68,
        0x05, 0x8E, 0x3A, 0xE7, 0x5C, 0x32, 0xCA, 0x07, 0xC0, 0x80,
        0x46, 0x6A, 0x30, 0x7B
    };
    static unsigned char dhg_512[] = {
        0x05
    };
    DH *dh = DH_new();
    BIGNUM *p, *g;

    if (dh == NULL)
        return NULL;
    p = BN_bin2bn(dhp_512, sizeof(dhp_512), NULL);
    g = BN_bin2bn(dhg_512, sizeof(dhg_512), NULL);
    if (p == NULL || g == NULL
            || !DH_set0_pqg(dh, p, NULL, g)) {
        DH_free(dh);
        BN_free(p);
        BN_free(g);
        return NULL;
    }
    return dh;
}
